logmode + addin
include ".\LDVeqouttab.prg"

%type = @getthistype	'check that an object exists
if %type="NONE" then
	seterr "No object found, please open an Equation object"
	stop
endif
if %type<>"EQUATION" then	'check that _this object is an equation
	seterr "Procedure can only be run from an Equation object"
	stop
endif
%method = _this.@method	'chech the method used
if %method <> "BINARY" and %method <> "COUNT" then
	seterr "Procedure can only be run from Equations estimated by Binary and Count"
	stop
endif

%bw = ""
%kernchoices = "Bartlett Parzen ""Quadratic-Spectral"""
%kerns = "bart parz quadspec"
%bwchoices = """User-Specified"" Andrews ""Fixed NW"""
	
!kernc = 1
!bwc = 1
!dogui = 1
!dodf = 1 

if @len(@option(1)) then
	!dodf = @hasoption("df")
	!kernc = @val(@equaloption("kern"))
	!bwc = @val(@equaloption("bw"))
	%bw = @equaloption("bwv")
	!dogui = 0
endif
	
if !dogui then
	!result = @uidialog("caption", "Long-run covariance", _
	"list", !kernc, "Kernel choice", %kernchoices, _
	 "list", !bwc, "Bandwidth Choice", %bwchoices, _
	 "edit",%bw,"User-specified BW", _
	 "check",!dodf,"DoF correct LR-covariance")	
	if !result = -1 then
		stop
	endif
endif	

%bwstr = ""
if !bwc = 1 then
	%bwstr = %bw
endif
if !bwc = 2 then
	%bwstr = "andrews"
endif
if !bwc = 3 then
	%bwstr = "fixednw"
endif

%tempmat =  @getnextname("_haccov") 
%lropt = "noc, out=%tempmat, kern=" + @word(%kerns,!kernc) + ", bw=" + %bwstr
string temp = %lropt
%outn =  @getnextname("_hccm") 
sym {%outn}
call DHAC({%outn},_this, %method, !dodf, %lropt)	

%names = _this.@varlist
%dnames = @wmid(%names,2) 'drop dependent
%tn = @getnextname("_table")
table(10,5) {%tn}
%tn2 = @getnextname("_temp")
freeze({%tn2}) _this.results
{%tn2}.copyrange 1 1 6 1 {%tn}  1 1 61
	
if !dodf = 1 then
	{%tn}.insertrow(7)	
	%tempstr = "HAC covariance matrix (Kernel=" +  @word(%kerns,!kernc) + ", BW=" + %bwstr + ", dof=" + @str(_this.@df) + ")"
else
	{%tn}.insertrow(7)	
	%tempstr = "HAC covariance matrix (Kernel=" +  @word(%kerns,!kernc) + ", BW=" + %bwstr + ")"
endif
{%tn}(7,1) = %tempstr

!row = 8
call maketable({%tn}, !row, _this.@coefs, {%outn}, %dnames, _this.@df)		
!i=1
while !i>0
	if {%tn2}(!i,3) = "    Mean dependent var" then
		exitloop
	endif
	!i=!i+1
wend
!startrow = !i
!endrow = !i+15
{%tn2}.copyrange !startrow 1 !endrow 5 {%tn}  !startrow 1 !endrow 5

_this.display {%tn} 
d {%tn} {%tn2} {%outn} {%tempeq} {%tempcov} {%tempgr} {%tempmat} {%gradstr}
		 	
subroutine DHAC(sym hccm, equation in, string %method, scalar df, string %lropt)	
	%opt = in.@options(1)
	%opt2 = @wdelim(%opt, ",", " ")
	%opt3 = @wdrop(%opt2, "H G")	 
	!isH = @wfindnc(%opt2, "H")
	!isG = @wfindnc(%opt2, "G")
	%tempcov = @getnextname("_cov")
	if !isH>0 or !isG>0 then
		%tempeq = @getnextname("_eq")
		copy in %tempeq
		in.updatecoef
		%cmd = %method  + "("+%opt3+")"
		{%tempeq}.{%cmd}
		sym {%tempcov} = {%tempeq}.@coefcov
	else 
		sym {%tempcov} = in.@coefcov
	endif
	
	!n = in.@regobs
	if df = 1 then
		{%tempcov} = {%tempcov}*!n/(!n-1)
	endif
	%tempgr = @getnextname("_mygr")
	%vars = in.@varlist
	%var = @wmid(%vars,2) 
	!no = @wcount(%var)
	%gradstr =""
	for !i=1 to !no
		%temp = @getnextname("_grad"+@str(!i))
		%gradstr = %gradstr + %temp + " "
	next	
	in.makegrads(n={%tempgr}) {%gradstr} 
	{%tempgr}.lrcov({%lropt})	
	hccm = {%tempcov}*!n*{%tempmat}*{%tempcov}
endsub
